{
    "$graph": [
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "arguments": [
                "sqlite3",
                "$(inputs.db)",
                "$('select json_object(\\'code_command\\', command) from code where title=\"' + inputs.code_title + '\";')",
                ".exit"
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#gk--get-code-command.cwl/code_title"
                },
                {
                    "type": "File",
                    "id": "#gk--get-code-command.cwl/db"
                }
            ],
            "stdout": "cwl.output.json",
            "id": "#gk--get-code-command.cwl",
            "outputs": [
                {
                    "type": "string",
                    "id": "#gk--get-code-command.cwl/code_command"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "arguments": [
                "sqlite3",
                "$(inputs.db)",
                "$('select json_object(\\'code_pseudo_ext\\', pseudo_ext) from code where title=\"' + inputs.code_title + '\";')",
                ".exit"
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#gk--get-code-pseudo-ext.cwl/code_title"
                },
                {
                    "type": "File",
                    "id": "#gk--get-code-pseudo-ext.cwl/db"
                }
            ],
            "stdout": "cwl.output.json",
            "outputs": [
                {
                    "type": "string",
                    "id": "#gk--get-code-pseudo-ext.cwl/code_pseudo_ext"
                }
            ],
            "id": "#gk--get-code-pseudo-ext.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "arguments": [
                "sqlite3",
                "$(inputs.db)",
                "$('select distinct json_object(\\'kind\\', kind) from pseudo;')",
                ".exit",
                {
                    "shellQuote": false,
                    "valueFrom": "|"
                },
                "jq",
                "-s",
                "{kinds: map(.kind)}"
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#gk--get-pseudo-kinds.cwl/code_title"
                },
                {
                    "type": "File",
                    "id": "#gk--get-pseudo-kinds.cwl/db"
                }
            ],
            "stdout": "cwl.output.json",
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#gk--get-pseudo-kinds.cwl/kinds"
                }
            ],
            "id": "#gk--get-pseudo-kinds.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "arguments": [
                "sqlite3",
                "$(inputs.db)",
                "$('SELECT (data) from pseudo WHERE (code_title,kind)=(\"' + inputs.code_title + '\",\"' + inputs.kind + '\");')",
                ".exit"
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#gk--load-pseudo.cwl/code_title"
                },
                {
                    "type": "File",
                    "id": "#gk--load-pseudo.cwl/db"
                },
                {
                    "type": "string",
                    "id": "#gk--load-pseudo.cwl/ext"
                },
                {
                    "type": "string",
                    "id": "#gk--load-pseudo.cwl/kind"
                }
            ],
            "stdout": "$(inputs.kind + '.' + inputs.ext)",
            "outputs": [
                {
                    "type": "File",
                    "id": "#gk--load-pseudo.cwl/pseudo_file",
                    "outputBinding": {
                        "glob": "$(inputs.kind + '.' + inputs.ext)"
                    }
                }
            ],
            "id": "#gk--load-pseudo.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "arguments": [
                "sqlite3",
                "$(inputs.db)",
                "$('SELECT (data) from input WHERE code_title=\"' + inputs.code_title + '\";')",
                ".exit"
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#gk-load-code-input.cwl/code_title"
                },
                {
                    "type": "File",
                    "id": "#gk-load-code-input.cwl/db"
                }
            ],
            "stdout": "input",
            "outputs": [
                {
                    "type": "File",
                    "id": "#gk-load-code-input.cwl/input_file",
                    "outputBinding": {
                        "glob": "input"
                    }
                }
            ],
            "id": "#gk-load-code-input.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#gk-load-code-pseudos.cwl/code_title"
                },
                {
                    "type": "File",
                    "id": "#gk-load-code-pseudos.cwl/db"
                }
            ],
            "steps": [
                {
                    "run": "#gk--get-code-pseudo-ext.cwl",
                    "in": [
                        {
                            "source": "#gk-load-code-pseudos.cwl/code_title",
                            "id": "#gk-load-code-pseudos.cwl/get_code_pseudo_ext/code_title"
                        },
                        {
                            "source": "#gk-load-code-pseudos.cwl/db",
                            "id": "#gk-load-code-pseudos.cwl/get_code_pseudo_ext/db"
                        }
                    ],
                    "out": [
                        "#gk-load-code-pseudos.cwl/get_code_pseudo_ext/code_pseudo_ext"
                    ],
                    "id": "#gk-load-code-pseudos.cwl/get_code_pseudo_ext"
                },
                {
                    "run": "#gk--get-pseudo-kinds.cwl",
                    "in": [
                        {
                            "source": "#gk-load-code-pseudos.cwl/code_title",
                            "id": "#gk-load-code-pseudos.cwl/get_pseudo_kinds/code_title"
                        },
                        {
                            "source": "#gk-load-code-pseudos.cwl/db",
                            "id": "#gk-load-code-pseudos.cwl/get_pseudo_kinds/db"
                        }
                    ],
                    "out": [
                        "#gk-load-code-pseudos.cwl/get_pseudo_kinds/kinds"
                    ],
                    "id": "#gk-load-code-pseudos.cwl/get_pseudo_kinds"
                },
                {
                    "run": "#gk--load-pseudo.cwl",
                    "scatter": "#gk-load-code-pseudos.cwl/load_code_pseudos/kind",
                    "in": [
                        {
                            "source": "#gk-load-code-pseudos.cwl/code_title",
                            "id": "#gk-load-code-pseudos.cwl/load_code_pseudos/code_title"
                        },
                        {
                            "source": "#gk-load-code-pseudos.cwl/db",
                            "id": "#gk-load-code-pseudos.cwl/load_code_pseudos/db"
                        },
                        {
                            "source": "#gk-load-code-pseudos.cwl/get_code_pseudo_ext/code_pseudo_ext",
                            "id": "#gk-load-code-pseudos.cwl/load_code_pseudos/ext"
                        },
                        {
                            "source": "#gk-load-code-pseudos.cwl/get_pseudo_kinds/kinds",
                            "id": "#gk-load-code-pseudos.cwl/load_code_pseudos/kind"
                        }
                    ],
                    "out": [
                        "#gk-load-code-pseudos.cwl/load_code_pseudos/pseudo_file"
                    ],
                    "id": "#gk-load-code-pseudos.cwl/load_code_pseudos"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#gk-load-code-pseudos.cwl/load_code_pseudos/pseudo_file",
                    "id": "#gk-load-code-pseudos.cwl/pseudo_files"
                }
            ],
            "id": "#gk-load-code-pseudos.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "arguments": [
                "sqlite3",
                "$(inputs.db)",
                ".mode column",
                "$('SELECT ' + 'printf(\\'%16.12E\\', pos_x),' + 'printf(\\'%16.12E\\', pos_y),' + 'printf(\\'%16.12E\\', pos_z),' + 'printf(\\'%16.12E\\', vel_x),' + 'printf(\\'%16.12E\\', vel_y),' + 'printf(\\'%16.12E\\', vel_z) FROM snapshot WHERE step=' + inputs.step + ' ORDER BY atom_id ASC;')",
                ".exit"
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#gk-load-siesta-xvs.cwl/db"
                },
                {
                    "type": "int",
                    "id": "#gk-load-siesta-xvs.cwl/step"
                }
            ],
            "stdout": "XVS.dat",
            "outputs": [
                {
                    "type": "File",
                    "id": "#gk-load-siesta-xvs.cwl/xvs_file",
                    "outputBinding": {
                        "glob": "XVS.dat"
                    }
                }
            ],
            "id": "#gk-load-siesta-xvs.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/db"
                },
                {
                    "type": "int",
                    "id": "#main/step"
                }
            ],
            "steps": [
                {
                    "run": "#gk--get-code-command.cwl",
                    "in": [
                        {
                            "default": "siesta",
                            "id": "#main/get-command/code_title"
                        },
                        {
                            "source": "#main/db",
                            "id": "#main/get-command/db"
                        }
                    ],
                    "out": [
                        "#main/get-command/code_command"
                    ],
                    "id": "#main/get-command"
                },
                {
                    "run": "#gk-load-code-input.cwl",
                    "in": [
                        {
                            "default": "siesta",
                            "id": "#main/load_input/code_title"
                        },
                        {
                            "source": "#main/db",
                            "id": "#main/load_input/db"
                        }
                    ],
                    "out": [
                        "#main/load_input/input_file"
                    ],
                    "id": "#main/load_input"
                },
                {
                    "run": "#gk-load-code-pseudos.cwl",
                    "in": [
                        {
                            "default": "siesta",
                            "id": "#main/load_pseudos/code_title"
                        },
                        {
                            "source": "#main/db",
                            "id": "#main/load_pseudos/db"
                        }
                    ],
                    "out": [
                        "#main/load_pseudos/pseudo_files"
                    ],
                    "id": "#main/load_pseudos"
                },
                {
                    "run": "#gk-load-siesta-xvs.cwl",
                    "in": [
                        {
                            "source": "#main/db",
                            "id": "#main/load_xvs/db"
                        },
                        {
                            "source": "#main/step",
                            "id": "#main/load_xvs/step"
                        }
                    ],
                    "out": [
                        "#main/load_xvs/xvs_file"
                    ],
                    "id": "#main/load_xvs"
                },
                {
                    "run": "#gk-run-siesta-with.cwl",
                    "in": [
                        {
                            "source": "#main/get-command/code_command",
                            "id": "#main/run_siesta/command"
                        },
                        {
                            "source": "#main/load_input/input_file",
                            "id": "#main/run_siesta/fdf"
                        },
                        {
                            "source": "#main/load_pseudos/pseudo_files",
                            "id": "#main/run_siesta/pseudos"
                        },
                        {
                            "source": "#main/load_xvs/xvs_file",
                            "id": "#main/run_siesta/xvs"
                        }
                    ],
                    "out": [
                        "#main/run_siesta/output_file"
                    ],
                    "id": "#main/run_siesta"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/run_siesta/output_file",
                    "id": "#main/gk_siesta_output"
                }
            ],
            "id": "#main"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "listing": [
                        "$(inputs.fdf)",
                        "$(inputs.pseudos)",
                        "$(inputs.xvs)"
                    ],
                    "class": "InitialWorkDirRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "arguments": [
                "$(inputs.command)",
                "$(inputs.fdf)"
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#gk-run-siesta-with.cwl/command"
                },
                {
                    "type": "File",
                    "id": "#gk-run-siesta-with.cwl/fdf"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#gk-run-siesta-with.cwl/pseudos"
                },
                {
                    "type": "File",
                    "id": "#gk-run-siesta-with.cwl/xvs"
                }
            ],
            "stdout": "output",
            "outputs": [
                {
                    "type": "File",
                    "id": "#gk-run-siesta-with.cwl/output_file",
                    "outputBinding": {
                        "glob": "output"
                    }
                }
            ],
            "id": "#gk-run-siesta-with.cwl"
        }
    ],
    "cwlVersion": "v1.2"
}
